org 100h

start:
inc bh
push 0xa000
pop es
mov al,13h
int 10h

palloop:
mov ax,cx
mov dx,0x3c8
out dx,al    ; select palette color
inc dx
or ax,dx
out dx,al    ; write red value (0..63)
xor ax,dx
out dx,al    ; write green value (0..63)
sub ax,dx
out dx,al    ; write blue value (0..63)
loop palloop

mainloop:
push bx
mov ax,0xCCCD
mul di

mov ax,dx
add ax,si
cmp bh,1
jnz tiled
xor bh,1
call [jump_table+bx]
xor bh,1
jmp draw_end
tiled:
call [jump_table+bx]
cmp dl,120

;Left side
jbe right

cmp dh,100
jbe bottom_left

;top left
add bl,2
and bl,7
call [jump_table+bx]
jmp draw_end

bottom_left:

sub al,ah
jmp draw_end

right:
mov ax,dx
sub ax,si
;add al,ah
;Left side

cmp dh,100
jbe bottom_right

;top left
add bl,4
and bl,7
call [jump_table+bx]

jmp draw_end
bottom_right:
add bl,6
and bl,7
call [jump_table+bx]

draw_end:
sub dx,0x6478
call ring_jsr

stosb
pop bx
loop mainloop

add si,0401h
jno music
add bl,2
and bl,7
jnz music
xor bh,1
music:
;some music
mov ax,si
or al,0x4B
out 0x42,al
out 0x61,al


in al,0x60
dec al
jnz mainloop

ret

effect_a:
and al,ah
neg ax
ret

effect_b:
xor al,ah
ret

effect_c:
xor ah,al
sub al,ah
xor al,ah
ret

effect_d:
and ah,al
add al, ah
xor al, ah
neg ax
ret

;Ring Subroutine
ring_jsr:
push ax
push bx

mov al,dh
imul al
mov bx,ax

mov al,dl
imul al
add ax,bx
mov bx,20
add bx,si
and bx,127
imul bx,bx

cmp ax,bx
jge inner_radius
pop bx
cmp bh,1
jnz inv1
pop dx
add ax,si
ret
inv1:
pop ax
ret

inner_radius:
pop bx
cmp bh,1
jnz inv2
pop ax
ret
inv2:
pop dx
sub ax,si
ret

jump_table:
dw effect_a
dw effect_b
dw effect_c
dw effect_d
